Subject: Re: tperf: An initial TSN Performance Utility

From: Ivan Khoronzhuk <[email-masked]>
Date: Tue, 3 Dec 2019 16:27:46 +0200

On Tue, Dec 03, 2019 at 10:00:15AM +0000, Jose Abreu wrote:
>Hi netdev,
>
>[ I added in cc the people I know that work with TSN stuff, please add
>anyone interested ]
>
>We are currently using a very basic tool for monitoring the CBS
>performance of Synopsys-based NICs which we called tperf. This was based
>on a patchset submitted by Jesus back in 2017 so credits to him and
>blames on me :)
>
>The current version tries to send "dummy" AVTP packets, and measures the
>bandwidth of both receiver and sender. By using this tool in conjunction
>with iperf3 we can check if CBS reserved queues are behaving correctly
>by reserving the priority traffic for AVTP packets.
>
>You can checkout the tool in the following address:
>	GitHub: https://github.com/joabreu/tperf
>
>We are open to improve this to more robust scenarios, so that we can
>have a common tool for TSN testing that's at the same time light
>weighted and precise.
>
>Anyone interested in helping ?

I've also have tool that already includes similar functionality.

https://github.com/ikhorn/plget

It's also about from 2016-2017 years.
Not ideal, but it helped me a lot for last years. Also worked with XDP, but
libbpf library is old already and should be updated. But mostly it was used to
get latencies and observe hw ts how packets are put on the line.

I've used it for CBS and for TAPRIO scheudler testing, observing h/w ts of each
packet, closed and open gates, but a target board should support hw ts to be
accurate, that's why ptp packets were used.

It includes also latency measurements based as on hw timestamp as on software
ts.

It also includes avtp and bw measurements with priorities, you've mentioned.
Now I have branch adding runtime measurement with plots.

-- 
Regards,
Ivan Khoronzhuk